/*
 * Created on 02.10.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package graph;

import java.util.*;
import java.awt.*;
import java.text.*;

/**
 * @author jfranke
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class BarFixedGraph extends StdGraph {
	private int stepping;
	private int max_scale_value;
	private boolean artificial_scale;

	public void paintGraph() {

		g.setColor(new Color(255, 255, 255));
		g.fillRect(0, 0, width, height);
		g.setColor(new Color(0, 0, 0));

		int rows = 0;
		rows = drawAnswer();
		upper_border = rows * fm.getHeight() + 5;
		lower_border = getMaxScaleRow() * fm.getHeight() + 2;
		//drawSingleValue(); Doesn't work right now!
		drawCoords();
		drawScale();
		drawLegend();

		drawBars(0, 3, "total");
		drawBars(1, 3, "branch");
		drawBars(2, 3, "single");

	}

	public int getMaxScaleRow() {
		int rowMax = 0;
		//Abstand kalkulieren
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);

		for (int i = 0; i < values.length; i++) {

			boolean out_complete = false;

			String output = values[i][1];
			String rest = values[i][1];
			int row = 0;

			while (!out_complete) {

				//Lnge des Strings ermitteln

				int s = fm.stringWidth(rest);

				if (s > space_x - 6) {

					int slen = 0;
					int idx = 0;
					while (slen < space_x - 6 && idx < rest.length()) {
						slen = slen + fm.charWidth(rest.charAt(idx));
						idx++;
					}
					idx--;
					//Vorgelagertes Leerzeichen ermitteln
					while (idx >= 0
						&& rest.charAt(idx) != new String(" ").charAt(0)) {
						idx--;
					}
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);

				} else {
					output = rest;
					out_complete = true;
				}

				row++;
			}
			if (row > rowMax)
				rowMax = row;
		}

		return rowMax + 3; //+2, um Gesamtzahlen noch aufzunehmen
	}
	public void drawVrtDotLine(int y1, int y2, int x, Graphics g) {
		boolean flag = true;
		int k = 0;
		int l = 3;
		for (int i = 0; i < y2 - y1; i++) {

			if (k > 0) {
				k--;
				flag = false;
			}
			if (l > 0) {
				flag = true;
				l--;
			}
			if (k == 1)
				l = 5;
			if (l == 1)
				k = 5;

			if (flag) {
				//Nur einen Punkt zeichnen
				g.drawLine(x, y1 + i, x, y1 + i);
			}

		}

	}
	public void drawSingleValue() {
		//Funktion, um die Einzelantwort auszugeben
		/*if (!applet.getParameter("single_value").equals("")) {
		
			int single = Integer.parseInt(applet.getParameter("single_value"));
			int idx = 9999;
			for (int i = 0; i < values.length; i++) {
				if (Integer.parseInt(values[i][2]) == single) {
					idx = i;
				}
			}
		
			if (idx != 9999) {
		
				int space_x =
					(int) ((width - left_border - right_border)
						/ values.length);
				g.setColor(color_sanswer);
				g.fillRect(
					left_border + idx * space_x,
					upper_border,
					space_x,
					height - upper_border);
				g.setColor(Color.BLACK);
			}
		}*/
	}
	public void drawScale() {

		//Abstand kalkulieren
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);

		for (int i = 0; i < values.length; i++) {
			if(values.length>=4) font=stdsmall;
			g.setFont(font);
			boolean out_complete = false;

			String output = values[i][1];
			String rest = values[i][1];
			int row = 0;

			while (!out_complete) {

				//Lnge des Strings ermitteln

				int s = fm.stringWidth(rest);

				if (s > space_x - 6) {

					int slen = 0;
					int idx = 0;
					while (slen < space_x - 6 && idx < rest.length()) {
						slen = slen + fm.charWidth(rest.charAt(idx));
						idx++;
					}
					idx--;
					//Vorgelagertes Leerzeichen ermitteln
					while (idx >= 0
						&& rest.charAt(idx) != new String(" ").charAt(0)) {
						idx--;
					}
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);

				} else {
					output = rest;
					out_complete = true;
				}
				s = fm.stringWidth(output);
				g.setFont(font);
				g.drawString(
					output,
					space_x / 2 + left_border + i * space_x - s / 2,
					height - lower_border + (1 + row) * fm.getHeight());
				row++;
			}

			g.setFont(stdsmall);

			String number = new String("N(Total)=" + values[i][4]);
			g.drawString(
				"N(Total)=" + values[i][4],
				space_x / 2
					+ left_border
					+ i * space_x
					- fmsmall.stringWidth(number) / 2,
				height - lower_border + (2 + row) * fmsmall.getHeight());

			String number_b = new String("N(Branch)=" + values[i][5]);
			g.drawString(
				"N(Branch)=" + values[i][4],
				space_x / 2
					+ left_border
					+ i * space_x
					- fmsmall.stringWidth(number) / 2,
				height - lower_border + (3 + row) * fmsmall.getHeight());

			g.setFont(font);

		}

	}
	public void drawLegend() {
		g.setFont(stdsmall);
		g.setColor(color_total);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7,
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		g.setColor(color_branch);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7 + fmsmall.getHeight() + 5,
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);

		g.setColor(color_sanswer);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7 + 2 * (fmsmall.getHeight() + 5),
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		g.setColor(color_total);

		g.setColor(Color.BLACK);
		g.drawString(
			"Total average",
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border + 7 + fmsmall.getAscent()));
		g.drawString(
			"Branch average",
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border
				+ 7
				+ fmsmall.getHeight()
				+ 5
				+ fmsmall.getAscent()));

		g.drawString(
			"Your answer",
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border
				+ 7
				+ 2 * (fmsmall.getHeight() + 5)
				+ fmsmall.getAscent()));

		g.setFont(font);
	}
	public void drawHrzDotLine(int x1, int x2, int y, Graphics g) {
		boolean flag = true;
		int k = 0;
		int l = 3;
		for (int i = 0; i < x2 - x1; i++) {

			if (k > 0) {
				k--;
				flag = false;
			}
			if (l > 0) {
				flag = true;
				l--;
			}
			if (k == 1)
				l = 5;
			if (l == 1)
				k = 5;

			if (flag) {
				//Nur einen Punkt zeichnen
				g.drawLine(x1 + i, y, x1 + i, y);
			}

		}

	}

	/**
	 * @param v
	 * @param s
	 */
	public BarFixedGraph(String[][] v, Starter s, Graphics g) {
		super(v, s, g);
		artificial_scale=false;
	}

	public int drawAnswer() {

		String answer = new String(applet.getParameter("antwort"));
		g.setFont(stdbold);

		boolean out_complete = false;

		String output = answer;
		String rest = answer;
		int row = 0;

		while (!out_complete) {

			//Lnge des Strings ermitteln

			int s = fm.stringWidth(rest);

			if (s > width - 30) {

				int slen = 0;
				int idx = 0;
				while (slen < width - 30 && idx < rest.length()) {
					slen = slen + fm.charWidth(rest.charAt(idx));
					idx++;
				}
				idx--;
				//Vorgelagertes Leerzeichen ermitteln
				while (idx >= 0
					&& rest.charAt(idx) != new String(" ").charAt(0)) {
					idx--;
				}
				if (idx <= 0) {
					out_complete = true;
					output = rest;
				} else {
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);
				}
			} else {
				output = rest;
				out_complete = true;
			}
			s = fm.stringWidth(output);
			g.drawString(output, 5, (1 + row) * fm.getHeight());
			row++;
		}

		g.setFont(font);
		return row;
	}

	public void drawBars(int order, int no_total, String type) {
		double sum = 0;
		int bar_width = 15;
		int t = 0; //defaults to total
		Color myColor = color_total;
		g.setFont(labelsfont);
		if (type.equals("total")) {
			t = 0;
			myColor = color_total;
		}
		if (type.equals("branch")) {
			t = 3;
			myColor = color_branch;
		}
		if (type.equals("single")) {
			t = 2;
			myColor = color_sanswer;
		}

		int disp_height = height - lower_border - upper_border;
		int bottom = height - lower_border;

		for (int j = 0; j < values.length; j++) {
			int space_x =
				(int) ((width - left_border - right_border) / values.length);
			int subspace_x = space_x / (no_total + 1);

			//Prfe, ob eine Antwort gegeben wurde
			if (values[j][t] == "n.a.") {
				g.setColor(new Color(0, 0, 0));
				g.drawString(
					"n.a.",
					(order + 1) * subspace_x
						+ left_border
						+ j * space_x
						- fmlabels.stringWidth("n.a.") / 2,
					(int) (bottom - 2));
			} else {

				//Rechtecke fuer jede Angabe zeichnen
				double bar_height =
					Double.parseDouble(values[j][t]) / max_scale_value;

				g.setColor(myColor);
				g.fillRect(
					left_border
						+ j * space_x
						+ (order + 1) * subspace_x
						- bar_width / 2,
					bottom - (int) ((bar_height * disp_height)),
					bar_width,
					(int) ((bar_height * disp_height)));

				String datalabel = df.format(Double.parseDouble(values[j][t]));
				//datalabel += "%";
				/*
				System.out.println("Data: " + Double.parseDouble(values[j][t]));
				System.out.println("Disp: " + disp_height);
				System.out.println("Bar: " + bar_height);
				System.out.println("height " + ((bar_height * disp_height)));
				System.out.println("MaxScale: " + max_scale);
				System.out.println("MaxScaleV: " + max_scale_value);
				*/
				g.setColor(new Color(0, 0, 0));
				g.drawString(
					datalabel,
					(order + 1) * subspace_x
						+ left_border
						+ j * space_x
						- fmlabels.stringWidth(datalabel) / 2,
					(int) (bottom - bar_height * disp_height - 2));
			}

		}

	}

	public void drawCoords() {

		//Achsen y1,y2,x
		g.drawLine(
			left_border,
			upper_border,
			left_border,
			height - lower_border);
		g.drawLine(
			width - right_border,
			upper_border,
			width - right_border,
			height - lower_border);
		g.drawLine(
			left_border,
			height - lower_border,
			width - right_border,
			height - lower_border);

		//Errechne y-Achse

		//Maximal darzustellenden Wert ermitteln

		double max_value = 0;
		for (int i = 0; i < values.length; i++) {
			double value = Double.parseDouble(values[i][0]);
			if (value > max_value)
				max_value = value;
			double value2 = Double.parseDouble(values[i][3]);
			if (value2 > max_value)
				max_value = value2;
			if (!(values[i][2].equals("n.a.") || values[i][2].equals(""))) {
				System.out.println("DEBUG: " + values[i][2]);
				double value3 = Double.parseDouble(values[i][2]);
				if (value3 > max_value)
					max_value = value3;
			}
		}

		//Optimale Schrittweite festlegen
		stepping = 10;

		if (max_value <= 100)
			stepping = 10;
		if (100 < max_value && max_value <= 200)
			stepping = 25;
		if (200 < max_value && max_value <= 500)
			stepping = 50;
		if (500 < max_value && max_value <= 1000)
			stepping = 100;
		if (1000 < max_value && max_value <= 5000)
			stepping = 500;
		if (5000 < max_value && max_value <= 10000)
			stepping = 1000;
		if (10000 < max_value && max_value <= 100000)
			stepping = 10000;
		if (100000 < max_value && max_value <= 1000000)
			stepping = 100000;
		if (1000000 < max_value)
			stepping = 1000000;

		//Maximalen Skalenpunkt ermitteln
		max_scale = (int) max_value;

		//Optimale Lnge der Anzeige als genaues Vielfaches des max. Skalenpunktes ermitteln
		int max_disp = height - upper_border - lower_border;

		/*
				int scale = (int) Math.floor(max_disp / (max_scale));
				upper_border += height
					- upper_border
					- lower_border
					- scale * max_scale;
		*/

		/*
		System.out.println("Scale: " + scale);
		System.out.println(" Values height=" + height + "uB:"+upper_border+"lB:"+lower_border+"sc:"+scale*max_scale);
		
		System.out.println("New Disp:" + (height-upper_border-lower_border+fm.getHeight()/2));
		*/
		//Abstand errechnen
		double space_y =
			(height - upper_border - lower_border)
				/ ((max_scale / stepping) + 1);

		//System.out.println("Dist y: "+ space_y);

		int bottom = height - lower_border;

		max_scale_value = 0;

		//Beschriftung einfgen
		for (int i = 0; i <= (max_scale / stepping) + 1; i++) {
			String label = String.valueOf(i * stepping);
			g.drawString(
				label,
				left_border - 55,
				bottom - (int) (i * space_y) + fm.getAscent() / 2);
			if (i > 0) {
				g.setColor(new Color(200, 200, 200));
				drawHrzDotLine(
					left_border + 1,
					width - (right_border + 1),
					bottom - (int) (i * space_y),
					g);
			}
			g.setColor(new Color(0, 0, 0));
			max_scale_value = (int) (i * stepping);
		}

	}
}
