/*
 * Created on 02.10.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package graph;

import java.util.*;
import java.awt.*;
import java.text.*;

/**
 * @author jfranke
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class BarFixedGraph extends StdGraph {
	private int stepping;
	private int step_div;
	private String step_desc;
	private int max_scale_value;
	private boolean artificial_scale;
	private boolean show_single;
	private int disp_height;

	public void paintGraph() {

		g.setColor(new Color(255, 255, 255));
		g.fillRect(0, 0, width, height);
		g.setColor(new Color(0, 0, 0));

		int rows = 0;
		rows = drawAnswer();
		upper_border = rows * fm.getHeight() + 5;
		lower_border = getMaxScaleRow() * fm.getHeight() + 2;

		drawCoords();
		drawScale();
		drawLegend();
		if (artificial_scale)
			drawArtLegend();

		if (show_single) {

			drawBars(0, 3, "total");
			drawBars(1, 3, "branch");
			drawBars(2, 3, "single");

			drawLabels(0, 3, "total");
			drawLabels(1, 3, "branch");
			drawLabels(2, 3, "single");
		} else {
			drawBars(0, 2, "total");
			drawBars(1, 2, "branch");

			drawLabels(0, 2, "total");
			drawLabels(1, 2, "branch");
		}

	}

	public int getMaxScaleRow() {
		int rowMax = 0;
		//Abstand kalkulieren

		if (artificial_scale)
			return 1;

		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);

		for (int i = 0; i < values.length; i++) {

			boolean out_complete = false;

			String output = values[i][1];
			String rest = values[i][1];
			int row = 0;

			while (!out_complete) {

				//Lnge des Strings ermitteln

				int s = fm.stringWidth(rest);

				if (s > space_x - 6) {

					int slen = 0;
					int idx = 0;
					while (slen < space_x - 6 && idx < rest.length()) {
						slen = slen + fm.charWidth(rest.charAt(idx));
						idx++;
					}
					idx--;
					//Vorgelagertes Leerzeichen ermitteln
					while (idx >= 0
						&& rest.charAt(idx) != new String(" ").charAt(0)) {
						idx--;
					}

					if (idx > rest.length()) {
						output = rest;
						out_complete = true;
					} else {

						output = rest.substring(0, idx);
						rest = rest.substring(idx + 1);
					}
				} else {
					output = rest;
					out_complete = true;
				}

				row++;
			}
			if (row > rowMax)
				rowMax = row;
		}

		return rowMax + 3; //+2, um Gesamtzahlen noch aufzunehmen
	}
	public void drawVrtDotLine(int y1, int y2, int x, Graphics g) {
		boolean flag = true;
		int k = 0;
		int l = 3;
		for (int i = 0; i < y2 - y1; i++) {

			if (k > 0) {
				k--;
				flag = false;
			}
			if (l > 0) {
				flag = true;
				l--;
			}
			if (k == 1)
				l = 5;
			if (l == 1)
				k = 5;

			if (flag) {
				//Nur einen Punkt zeichnen
				g.drawLine(x, y1 + i, x, y1 + i);
			}

		}

	}
	public void drawSingleValue() {
		//Funktion, um die Einzelantwort auszugeben
		/*if (!applet.getParameter("single_value").equals("")) {
		
			int single = Integer.parseInt(applet.getParameter("single_value"));
			int idx = 9999;
			for (int i = 0; i < values.length; i++) {
				if (Integer.parseInt(values[i][2]) == single) {
					idx = i;
				}
			}
		
			if (idx != 9999) {
		
				int space_x =
					(int) ((width - left_border - right_border)
						/ values.length);
				g.setColor(color_sanswer);
				g.fillRect(
					left_border + idx * space_x,
					upper_border,
					space_x,
					height - upper_border);
				g.setColor(Color.BLACK);
			}
		}*/
	}
	public void drawScale() {

		//Abstand kalkulieren
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);

		for (int i = 0; i < values.length; i++) {
			if (values.length >= 4)
				font = stdsmall;
			g.setFont(font);
			boolean out_complete = false;

			String output = values[i][1];
			String rest = values[i][1];
			int row = 0;
			if (!artificial_scale) {
				while (!out_complete) {

					//Lnge des Strings ermitteln

					int s = fm.stringWidth(rest);

					if (s > space_x - 6) {

						int slen = 0;
						int idx = 0;
						while (slen < space_x - 6 && idx < rest.length()) {
							slen = slen + fm.charWidth(rest.charAt(idx));
							idx++;
						}
						idx--;
						//Vorgelagertes Leerzeichen ermitteln
						while (idx >= 0
							&& rest.charAt(idx) != new String(" ").charAt(0)) {
							idx--;
						}
						output = rest.substring(0, idx);
						rest = rest.substring(idx + 1);

					} else {
						output = rest;
						out_complete = true;
					}

					s = fm.stringWidth(output);
					g.setFont(font);
					g.drawString(
						output,
						space_x / 2 + left_border + i * space_x - s / 2,
						height - lower_border + (1 + row) * fm.getHeight());
					row++;
				}
			} else {
				g.setFont(font);
				int s = fm.stringWidth("(" + (i + 1) + ")");
				g.drawString(
					"(" + (i + 1) + ")",
					space_x / 2 + left_border + i * space_x - s / 2,
					height - lower_border + (1 + row) * fm.getHeight());
			}

			g.setFont(stdsmall);

			if (!artificial_scale) {

				String number = new String("N(total)=" + values[i][4]);
				g.drawString(
					"N(total)=" + values[i][4],
					space_x / 2
						+ left_border
						+ i * space_x
						- fmsmall.stringWidth(number) / 2,
					height - lower_border + (2 + row) * fmsmall.getHeight());

				String number_b = new String("N(branch)=" + values[i][5]);
				g.drawString(
					"N(branch)=" + values[i][5],
					space_x / 2
						+ left_border
						+ i * space_x
						- fmsmall.stringWidth(number) / 2,
					height - lower_border + (3 + row) * fmsmall.getHeight());
			}

			g.setFont(font);

		}

	}
	public void drawArtLegend() {
		//Methode zeichnet zusaetzlich Legendenbeschriftung, falls Eintraege nicht passen
		g.setFont(stdsmall);

		g.setColor(Color.BLACK);
		g.drawString(
			"Legend",
			(int) (width - right_border + 7),
			(int) (upper_border + 7 + 5 * fmsmall.getHeight()));

		int rows = 0;

		for (int i = 0; i < values.length; i++) {
			//Datenbeschriftung
			g.drawString(
				"(" + (i + 1) + ")",
				(int) (width - right_border + 7),
				(int) (upper_border + 7 + (6 + rows) * fmsmall.getHeight()));

			//Zeilenumbruch
			String[] lines =
				lineFeed(
					values[i][1],
					right_border - 10 - fmsmall.stringWidth("(0) "),
					fmsmall);

			for (int k = 0; k < lines.length; k++) {

				g.drawString(
					lines[k],
					(int) (width
						- right_border
						+ 7
						+ fmsmall.stringWidth("(0) ")),
					(int) (upper_border
						+ 7
						+ (6 + rows) * fmsmall.getHeight()));
				rows++;

			}

		}

		g.setFont(font);

	}

	public void drawLegend() {
		g.setFont(stdsmall);
		g.setColor(color_total);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7,
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		g.setColor(color_branch);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7 + fmsmall.getHeight() + 5,
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		if (show_single) {

			g.setColor(color_sanswer);
			g.fillRect(
				width - right_border + 7,
				upper_border + 7 + 2 * (fmsmall.getHeight() + 5),
				fmsmall.getHeight() - 2,
				fmsmall.getHeight() - 2);
			g.setColor(color_total);
		}
		g.setColor(Color.BLACK);
		g.drawString(
			applet.getParameter("label"),
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border + 7 + fmsmall.getAscent()));
		g.drawString(
			applet.getParameter("label_b"),
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border
				+ 7
				+ fmsmall.getHeight()
				+ 5
				+ fmsmall.getAscent()));
		if (show_single)
			g.drawString(
				"Your answer",
				(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
				(int) (upper_border
					+ 7
					+ 2 * (fmsmall.getHeight() + 5)
					+ fmsmall.getAscent()));

		g.setFont(font);
	}
	public void drawHrzDotLine(int x1, int x2, int y, Graphics g) {
		boolean flag = true;
		int k = 0;
		int l = 3;
		for (int i = 0; i < x2 - x1; i++) {

			if (k > 0) {
				k--;
				flag = false;
			}
			if (l > 0) {
				flag = true;
				l--;
			}
			if (k == 1)
				l = 5;
			if (l == 1)
				k = 5;

			if (flag) {
				//Nur einen Punkt zeichnen
				g.drawLine(x1 + i, y, x1 + i, y);
			}

		}

	}

	/**
	 * @param v
	 * @param s
	 */
	public BarFixedGraph(String[][] v, Starter s, Graphics g) {
		super(v, s, g);
		if (values.length >= 4) {
			artificial_scale = true;
		} else {
			artificial_scale = false;
		}

		if (applet.getParameter("single").equals("false")) {
			show_single = false;
		} else {
			show_single = true;
		}
	}

	public int drawAnswer() {

		String answer = new String(applet.getParameter("antwort"));
		g.setFont(stdbold);

		boolean out_complete = false;

		String output = answer;
		String rest = answer;
		int row = 0;

		while (!out_complete) {

			//Lnge des Strings ermitteln

			int s = fm.stringWidth(rest);

			if (s > width - 30) {

				int slen = 0;
				int idx = 0;
				while (slen < width - 30 && idx < rest.length()) {
					slen = slen + fm.charWidth(rest.charAt(idx));
					idx++;
				}
				idx--;
				//Vorgelagertes Leerzeichen ermitteln
				while (idx >= 0
					&& rest.charAt(idx) != new String(" ").charAt(0)) {
					idx--;
				}
				if (idx <= 0) {
					out_complete = true;
					output = rest;
				} else {
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);
				}
			} else {
				output = rest;
				out_complete = true;
			}
			s = fm.stringWidth(output);
			g.drawString(output, 5, (1 + row) * fm.getHeight());
			row++;
		}
		g.setFont(font);
		return row;
	}

	public void drawLabels(int order, int no_total, String type) {

		int t = 0; //defaults to total
		Color myColor = color_total;
		g.setFont(labelsfont);
		if (type.equals("total")) {
			t = 0;
		}
		if (type.equals("branch")) {
			t = 3;
		}
		if (type.equals("single")) {
			t = 2;
		}

		int disp_height = height - lower_border - upper_border;
		int bottom = height - lower_border;

		for (int j = 0; j < values.length; j++) {
			int space_x =
				(int) ((width - left_border - right_border) / values.length);
			int subspace_x = space_x / (no_total + 1);

			//Prfe, ob eine Antwort gegeben wurde
			if (values[j][t].equals("n.a.") || values[j][t].equals(null)) {
				g.setColor(new Color(0, 0, 0));
				g.drawString(
					"n.a.",
					(order + 1) * subspace_x
						+ left_border
						+ j * space_x
						- fmlabels.stringWidth("n.a.") / 2,
					(int) (bottom - 2));
			} else {

				//Rechtecke fuer jede Angabe zeichnen
				double bar_height =
					Double.parseDouble(values[j][t]) / max_scale_value;

				String datalabel = df.format(Double.parseDouble(values[j][t]));
				g.setColor(new Color(0, 0, 0));
				g.drawString(
					datalabel,
					(order + 1) * subspace_x
						+ left_border
						+ j * space_x
						- fmlabels.stringWidth(datalabel) / 2,
					(int) (bottom - bar_height * disp_height - 2));
			}

		}

	}

	public void drawBars(int order, int no_total, String type) {
		double sum = 0;
		int bar_width = 15;
		int t = 0; //defaults to total
		Color myColor = color_total;
		g.setFont(labelsfont);
		if (type.equals("total")) {
			t = 0;
			myColor = color_total;
		}
		if (type.equals("branch")) {
			t = 3;
			myColor = color_branch;
		}
		if (type.equals("single")) {
			t = 2;
			myColor = color_sanswer;
		}

		//int disp_height = height - lower_border - upper_border;
		int bottom = height - lower_border;

		for (int j = 0; j < values.length; j++) {
			int space_x =
				(int) ((width - left_border - right_border) / values.length);
			int subspace_x = space_x / (no_total + 1);

			//Rechtecke fuer jede Angabe zeichnen
			if (!values[j][t].equals("n.a.")) {

				double bar_height =
					Double.parseDouble(values[j][t]) / max_scale_value;
				g.setColor(myColor);
				g.fillRect(
					left_border
						+ j * space_x
						+ (order + 1) * subspace_x
						- bar_width / 2,
					bottom - (int) ((bar_height * disp_height)),
					bar_width,
					(int) ((bar_height * disp_height)));
			}

		}

	}

	public void drawCoords() {

		//Achsen y1,y2,x
		g.drawLine(
			left_border,
			upper_border,
			left_border,
			height - lower_border);
		g.drawLine(
			width - right_border,
			upper_border,
			width - right_border,
			height - lower_border);
		g.drawLine(
			left_border,
			height - lower_border,
			width - right_border,
			height - lower_border);

		//Errechne y-Achse

		//Maximal darzustellenden Wert ermitteln

		double max_value = 0;
		for (int i = 0; i < values.length; i++) {
			if (!(values[i][0].equals("n.a.") || values[i][0].equals(""))) {
				double value = Double.parseDouble(values[i][0]);
				if (value > max_value)
					max_value = value;
			}

			if (!(values[i][3].equals("n.a.") || values[i][3].equals(""))) {
				double value2 = Double.parseDouble(values[i][3]);
				if (value2 > max_value)
					max_value = value2;
			}
			if (!(values[i][2].equals("n.a.") || values[i][2].equals(""))) {
				double value3 = Double.parseDouble(values[i][2]);
				if (value3 > max_value)
					max_value = value3;
			}
		}

		//Optimale Schrittweite festlegen
		stepping = 10;
		step_div = 1;
		step_desc = new String("");

		if (max_value <= 100)
			stepping = 10;
		if (100 < max_value && max_value <= 200)
			stepping = 25;
		if (200 < max_value && max_value <= 500)
			stepping = 50;
		if (500 < max_value && max_value <= 1000)
			stepping = 100;
		if (1000 < max_value && max_value <= 5000)
			stepping = 500;
		if (5000 < max_value && max_value <= 10000)
			stepping = 1000;
		if (10000 < max_value && max_value <= 100000) {
			stepping = 10000;
			step_div = 1000;
			step_desc = "Tsd.";
		}

		if (100000 < max_value && max_value <= 1000000) {
			stepping = 100000;
			step_div = 1000;
			step_desc = "Tsd.";
		}

		if (1000000 < max_value && max_value <= 50000000) {
			stepping = 1000000;
			step_div = 1000000;
			step_desc = "Mio.";
		}

		if (50000000 < max_value) {

			stepping = 10000000;
			step_div = 1000000;
			step_desc = "Mio.";
		}

		//Maximalen Skalenpunkt ermitteln
		max_scale = (int) max_value;

		//Optimale Lnge der Anzeige als genaues Vielfaches des max. Skalenpunktes ermitteln
		int max_disp = height - upper_border - lower_border;

		//Abstand errechnen
		double space_y =
			(height - upper_border - lower_border)
				/ ((max_scale / stepping) + 1);

		int bottom = height - lower_border;

		max_scale_value = 0;
		int count = 0;
		//Beschriftung einfgen
		for (int i = 0; i <= (max_scale / stepping) + 1; i++) {
			count++;
			String label = new String();
			if (i == 0) {
				label = String.valueOf(i * stepping / step_div);
			} else {
				if (step_desc.length() > 0) {
					label =
						String.valueOf(i * stepping / step_div)
							+ " "
							+ step_desc;
				} else {
					label = String.valueOf(i * stepping / step_div);
				}

			}

			g.drawString(
				label,
				left_border - 55,
				bottom - (int) (i * space_y) + fm.getAscent() / 2);
			if (i > 0) {
				g.setColor(new Color(200, 200, 200));
				drawHrzDotLine(
					left_border + 1,
					width - (right_border + 1),
					bottom - (int) (i * space_y),
					g);
			}
			g.setColor(new Color(0, 0, 0));
			max_scale_value = (int) (i * stepping);
		}
		disp_height = (int) ((count - 1) * space_y);
	}

	public String[] lineFeed(
		String inputString,
		int width,
		FontMetrics thisFont) {

		String[] outputString = new String[1];
		boolean out_complete = false;

		String rest = inputString;
		int row = 0;

		while (!out_complete) {

			//Lnge des Strings ermitteln

			int s = thisFont.stringWidth(rest);

			if (s > width) {

				int slen = 0;
				int idx = 0;
				int idx_tmp=0;
				while (slen < width && idx < rest.length()) {
					slen = slen + thisFont.charWidth(rest.charAt(idx));
					idx++;
				}
				idx--;
				idx_tmp=idx;
				//Vorgelagertes Leerzeichen ermitteln
				while (idx > 0
					&& rest.charAt(idx) != new String(" ").charAt(0)) {
					idx--;
				}
				if(idx==0){
					//Umbruch im Wort veranlassen
					idx=idx_tmp;
				}

				//Output-String erweitern
				String[] newString = new String[row + 1];
				//Inhalte des Original-Strings einkopieren
				for (int p = 0; p < outputString.length; p++) {
					newString[p] = outputString[p];
				}
				newString[row] = rest.substring(0, idx);

				outputString = newString;

				rest = rest.substring(idx + 1);

			} else {
				//Output-String erweitern
				String[] tempString = new String[row + 1];
				//Inhalte des Original-Strings einkopieren
				for (int p = 0; p < outputString.length; p++) {
					tempString[p] = outputString[p];
				}
				tempString[row] = rest;

				outputString = tempString;

				out_complete = true;
			}
			row++;
		}

		return outputString;
	}

}