/*
 * Created on 02.10.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package graph;

import java.util.*;
import java.awt.*;
import java.text.*;

/**
 * @author jfranke
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class BarGraph extends StdGraph {

	public void paintGraph() {

		g.setColor(new Color(255, 255, 255));
		g.fillRect(0, 0, width, height);
		g.setColor(new Color(0, 0, 0));

		int rows = 0;
		rows = drawAnswer();
		upper_border = rows * fm.getHeight() + 5;
		lower_border = getMaxScaleRow() * fm.getHeight() + 2;
		drawSingleValue();
		drawCoords();
		drawLegend();

		//Test, ob genug Werte fr eine Branchendarstellung vorhanden sind
		double sum = 0;
		for (int i = 0; i < values.length; i++) {
			if (!values[i][4].equals("0")) {
				sum += Double.parseDouble(values[i][3]);
			}
		}
		if (sum > 0)
			show_branch = true;

		if (calc_mean) {
			drawMean("total");
			if (show_branch)
				drawMean("branch");
		}
		if (show_branch) {
			drawBars(0, 2, "total");
			drawBars(1, 2, "branch");
		} else {
			drawBars(0, 1, "total");

		}

	}

	public int getMaxScaleRow() {
		int rowMax = 0;
		//Abstand kalkulieren
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);

		for (int i = 0; i < values.length; i++) {

			boolean out_complete = false;

			String output = values[i][1];
			String rest = values[i][1];
			int row = 0;

			while (!out_complete) {

				//Lnge des Strings ermitteln

				int s = fm.stringWidth(rest);

				if (s > space_x - 6) {

					int slen = 0;
					int idx = 0;
					while (slen < space_x - 6 && idx < rest.length()) {
						slen = slen + fm.charWidth(rest.charAt(idx));
						idx++;
					}
					idx--;
					//Vorgelagertes Leerzeichen ermitteln
					while (idx >= 0
						&& rest.charAt(idx) != new String(" ").charAt(0)) {
						idx--;
					}
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);

				} else {
					output = rest;
					out_complete = true;
				}

				row++;
			}
			if (row > rowMax)
				rowMax = row;
		}

		return rowMax;
	}
	public void drawVrtDotLine(int y1, int y2, int x, Graphics g) {
		boolean flag = true;
		int k = 0;
		int l = 3;
		for (int i = 0; i < y2 - y1; i++) {

			if (k > 0) {
				k--;
				flag = false;
			}
			if (l > 0) {
				flag = true;
				l--;
			}
			if (k == 1)
				l = 5;
			if (l == 1)
				k = 5;

			if (flag) {
				//Nur einen Punkt zeichnen
				g.drawLine(x, y1 + i, x, y1 + i);
			}

		}

	}
	public void drawSingleValue() {
		//Funktion, um die Einzelantwort auszugeben
		if (!applet.getParameter("single_value").equals("")) {

			int single = Integer.parseInt(applet.getParameter("single_value"));
			int idx = 9999;
			for (int i = 0; i < values.length; i++) {
				if (Integer.parseInt(values[i][2]) == single) {
					idx = i;
				}
			}

			if (idx != 9999) {

				int space_x =
					(int) ((width - left_border - right_border)
						/ values.length);
				g.setColor(color_sanswer);
				g.fillRect(
					left_border + idx * space_x,
					upper_border,
					space_x,
					height - upper_border);
				g.setColor(Color.BLACK);
			}
		}
	}
	public void drawScale() {

		g.setFont(font);
		//Abstand kalkulieren
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);

		for (int i = 0; i < values.length; i++) {

			boolean out_complete = false;

			String output = values[i][1];
			String rest = values[i][1];
			int row = 0;

			while (!out_complete) {

				//Lnge des Strings ermitteln

				int s = fm.stringWidth(rest);

				if (s > space_x - 6) {

					int slen = 0;
					int idx = 0;
					while (slen < space_x - 6 && idx < rest.length()) {
						slen = slen + fm.charWidth(rest.charAt(idx));
						idx++;
					}
					idx--;
					//Vorgelagertes Leerzeichen ermitteln
					while (idx >= 0
						&& rest.charAt(idx) != new String(" ").charAt(0)) {
						idx--;
					}
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);

				} else {
					output = rest;
					out_complete = true;
				}
				s = fm.stringWidth(output);
				g.drawString(
					output,
					space_x / 2 + left_border + i * space_x - s / 2,
					height - lower_border + (1 + row) * fm.getHeight());
				row++;
			}
		}

	}
	public void drawMean(String type) {
		int t = 0; //defaults total
		Color myColor = color_total;
		if (type.equals("total")) {
			t = 0;
			myColor = color_total;
		}
		if (type.equals("branch")) {
			t = 3;
			myColor = color_branch;
		}

		double sum = 0;
		double meansum = 0;
		double mean = 0;
		for (int i = 0; i < values.length; i++) {
			if (!values[i][4].equals("0")) {
				sum += Double.parseDouble(values[i][t]);
			}
		}
		for (int i = 0; i < values.length; i++) {
			meansum += Double.parseDouble(values[i][4])
				* (Double.parseDouble(values[i][t]));
		}
		mean = meansum / sum;
		int k = 0;
		//Anzahl der nicht mitgezaehlten Skalen ermitteln
		for (int i = 0; i < values.length; i++) {
			if (Integer.parseInt(values[i][4]) == 0)
				k++;
		}
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);
		int disp_width = width - left_border - right_border - k * space_x;

		//Ersten Wert als Referenzpunkt festlegen
		double calc = (double) (space_x) / 2 / Integer.parseInt(values[0][4]);

		g.setColor(myColor);
		if(mean>0){
		
		drawVrtDotLine(
			upper_border,
			height - lower_border,
			(int) (left_border + space_x * mean - calc),
			g);
		}
		g.setColor(Color.BLACK);
	}
	public void drawLegend() {
		g.setFont(stdsmall);
		g.setColor(color_total);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7,
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		g.setColor(color_branch);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7 + fmsmall.getHeight() + 5,
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		if (!applet.getParameter("single_value").equals("")) {
			g.setColor(color_sanswer);
			g.fillRect(
				width - right_border + 7,
				upper_border + 7 + 2 * (fmsmall.getHeight() + 5),
				fmsmall.getHeight() - 2,
				fmsmall.getHeight() - 2);
			g.setColor(color_total);
		}
		if (calc_mean) {
			drawVrtDotLine(
				upper_border + 7 + 3 * (fmsmall.getHeight() + 5),
				upper_border
					+ 7
					+ 3 * (fmsmall.getHeight() + 5)
					+ fmsmall.getHeight(),
				width - right_border + 7 + fmsmall.getHeight() / 2,
				g);
			if (show_branch) {

				g.setColor(color_branch);
				drawVrtDotLine(
					upper_border + 7 + 4 * (fmsmall.getHeight() + 5),
					upper_border
						+ 7
						+ 4 * (fmsmall.getHeight() + 5)
						+ fmsmall.getHeight(),
					width - right_border + 7 + fmsmall.getHeight() / 2,
					g);
			}
		}
		g.setColor(Color.BLACK);
		g.drawString(
			"Total",
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border + 7 + fmsmall.getAscent()));
		g.drawString(
			"Branch",
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border
				+ 7
				+ fmsmall.getHeight()
				+ 5
				+ fmsmall.getAscent()));
		if (!applet.getParameter("single_value").equals("")) {
			g.drawString(
				"Your answer",
				(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
				(int) (upper_border
					+ 7
					+ 2 * (fmsmall.getHeight() + 5)
					+ fmsmall.getAscent()));
		}
		if (calc_mean) {
			g.drawString(
				"Total average",
				(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
				(int) (upper_border
					+ 7
					+ 3 * (fmsmall.getHeight() + 5)
					+ fmsmall.getAscent()));

			if (show_branch)
				g.drawString(
					"Branch average",
					(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
					(int) (upper_border
						+ 7
						+ 4 * (fmsmall.getHeight() + 5)
						+ fmsmall.getAscent()));
			int h = 0;
			for (int i = 0; i < values.length; i++) {
				if (values[i][4].equals("0"))
					h++;
			}
			if (h > 0) {

				g.drawString(
					"Nicht im MW",
					(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
					(int) (upper_border
						+ 7
						+ 6 * (fmsmall.getHeight() + 5)
						+ fmsmall.getAscent()));
				g.drawString(
					"enthaltene Skalen:",
					(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
					(int) (upper_border
						+ 7 * (fmsmall.getHeight() + 5)
						+ fmsmall.getAscent()));
				int p = 0;
				for (int i = 0; i < values.length; i++) {

					if (values[i][4].equals("0")) {
						p++;
						g.drawString(
							"\"" + values[i][1] + "\"",
							(int) (width
								- right_border
								+ 7
								+ fmsmall.getHeight()
								+ 2),
							(int) (upper_border
								+ (7 + p) * (fmsmall.getHeight() + 5)
								- 4
								+ fmsmall.getAscent()));
					}
				}
			}

		}

		int sum = 0;
		int sum_b = 0;
		for (int i = 0; i < values.length; i++) {
			sum += Integer.parseInt(values[i][0]);

		}
		for (int i = 0; i < values.length; i++) {
			sum_b += Integer.parseInt(values[i][3]);
		}
		String star1 = new String();
		String star2 = new String();
		if (sum < 10)
			star1 = "*";
		if (sum_b < 10)
			star2 = "*";

		g.drawString(
			"N(Gesamt)=" + sum + star1,
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (height
				- lower_border
				- 2 * fmsmall.getHeight()
				+ fmsmall.getAscent()));
		if (show_branch)
			g.drawString(
				"N(Branche)=" + sum_b + star2,
				(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
				(int) (height
					- lower_border
					- 1 * fmsmall.getHeight()
					+ fmsmall.getAscent()));

		g.setFont(font);
	}
	public void drawHrzDotLine(int x1, int x2, int y, Graphics g) {
		boolean flag = true;
		int k = 0;
		int l = 3;
		for (int i = 0; i < x2 - x1; i++) {

			if (k > 0) {
				k--;
				flag = false;
			}
			if (l > 0) {
				flag = true;
				l--;
			}
			if (k == 1)
				l = 5;
			if (l == 1)
				k = 5;

			if (flag) {
				//Nur einen Punkt zeichnen
				g.drawLine(x1 + i, y, x1 + i, y);
			}

		}

	}

	/**
	 * @param v
	 * @param s
	 */
	public BarGraph(String[][] v, Starter s, Graphics g) {
		super(v, s, g);
	}

	public int drawAnswer() {

		String answer = new String(applet.getParameter("antwort"));
		g.setFont(stdbold);

		boolean out_complete = false;

		String output = answer;
		String rest = answer;
		int row = 0;

		while (!out_complete) {

			//Lnge des Strings ermitteln

			int s = fm.stringWidth(rest);

			if (s > width - 10) {

				int slen = 0;
				int idx = 0;
				while (slen < width - 10 && idx < rest.length()) {
					slen = slen + fm.charWidth(rest.charAt(idx));
					idx++;
				}
				idx--;
				//Vorgelagertes Leerzeichen ermitteln
				while (idx >= 0
					&& rest.charAt(idx) != new String(" ").charAt(0)) {
					idx--;
				}
				if (idx <= 0) {
					out_complete = true;
					output = rest;
				} else {
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);
				}
			} else {
				output = rest;
				out_complete = true;
			}
			s = fm.stringWidth(output);
			g.drawString(output, 5, (1 + row) * fm.getHeight());
			row++;
		}

		g.setFont(font);
		return row;
	}

	public void drawBars(int order, int no_total, String type) {
		double sum = 0;
		int bar_width = 15;
		int t = 0; //defaults to total
		Color myColor = color_total;
		g.setFont(labelsfont);
		if (type.equals("total")) {
			t = 0;
			myColor = color_total;
		}
		if (type.equals("branch")) {
			t = 3;
			myColor = color_branch;
		}
		//Summe errechnen
		for (int i = 0; i < values.length; i++) {
			sum += Double.parseDouble(values[i][t]);
		}

		int disp_height = height - lower_border - upper_border;
		int bottom = height - lower_border;

		for (int j = 0; j < values.length; j++) {
			//Rechtecke fuer jede Angabe zeichnen
			double bar_height = Double.parseDouble(values[j][t]) / sum;
			int space_x =
				(int) ((width - left_border - right_border) / values.length);

			int subspace_x = space_x / (no_total + 1);

			g.setColor(myColor);
			g.fillRect(
				left_border
					+ j * space_x
					+ (order + 1) * subspace_x
					- bar_width / 2,
				bottom - (int) ((bar_height * disp_height) * 100 / max_scale),
				bar_width,
				(int) ((bar_height * disp_height) * 100 / max_scale));

			String datalabel = df.format(bar_height * 100);
			//datalabel += "%";
			/*
			System.out.println("Data: " + datalabel);
			System.out.println("Disp: " + disp_height);
			System.out.println("Bar: " + bar_height);
			System.out.println("height " + ((bar_height * disp_height) * 100 / max_scale));
			System.out.println("MaxScale: " + max_scale);
			*/
			g.setColor(new Color(0, 0, 0));
			g.drawString(
				datalabel,
				(order + 1) * subspace_x
					+ left_border
					+ j * space_x
					- fmlabels.stringWidth(datalabel) / 2,
				(int) (bottom
					- bar_height * disp_height * 100 / max_scale
					- 2));

		}

	}

	public void drawCoords() {

		//Achsen y1,y2,x
		g.drawLine(
			left_border,
			upper_border,
			left_border,
			height - lower_border);
		g.drawLine(
			width - right_border,
			upper_border,
			width - right_border,
			height - lower_border);
		g.drawLine(
			left_border,
			height - lower_border,
			width - right_border,
			height - lower_border);

		//Errechne y-Achse

		//Maximal darzustellenden Wert ermitteln
		double sum = 0;
		double sum_b = 0;
		for (int i = 0; i < values.length; i++) {
			sum += Double.parseDouble(values[i][0]);
			sum_b += Double.parseDouble(values[i][3]);
		}

		double max_value = 0;
		for (int i = 0; i < values.length; i++) {
			double value = Double.parseDouble(values[i][0]) / sum;
			if (value > max_value)
				max_value = value;
			double value2 = Double.parseDouble(values[i][3]) / sum_b;
			if (value2 > max_value)
				max_value = value2;
		}

		//Maximalen Skalenpunkt ermitteln
		max_scale = (int) Math.floor(max_value * 100);

		if (max_scale % 10 >= 4 && max_scale % 10 != 0) {
			max_scale += Math.abs((max_scale % 10) - 10) + 10;
		} else {
			max_scale += Math.abs((max_scale % 10) - 10);
		}
		if (max_scale >= 96)
			max_scale = 100;

		//Optimale Lnge der Anzeige als genaues Vielfaches des max. Skalenpunktes ermitteln
		int max_disp = height - upper_border - lower_border;

		//System.out.println("maxDisp: " + max_disp);

		int scale = (int) Math.floor(max_disp / (max_scale));
		upper_border += height
			- upper_border
			- lower_border
			- scale * max_scale;
		/*
		System.out.println("Scale: " + scale);
		System.out.println(" Values height=" + height + "uB:"+upper_border+"lB:"+lower_border+"sc:"+scale*max_scale);
		
		System.out.println("New Disp:" + (height-upper_border-lower_border+fm.getHeight()/2));
		*/
		//Abstand errechnen
		double space_y =
			(height - upper_border - lower_border) / (max_scale / 10);

		//System.out.println("Dist y: "+ space_y);

		int bottom = height - lower_border;

		//Prozentbeschriftung einfgen
		for (int i = 0; i <= max_scale / 10; i++) {
			String label = i * 10 + " %";
			g.drawString(
				label,
				left_border - 55,
				bottom - (int) (i * space_y) + fm.getAscent() / 2);
			if (i > 0) {
				g.setColor(new Color(200, 200, 200));
				drawHrzDotLine(
					left_border + 1,
					width - (right_border + 1),
					bottom - (int) (i * space_y),
					g);
			}
			g.setColor(new Color(0, 0, 0));

		}

		//Skala zeichnen
		drawScale();

	}
}
