/*
 * Created on 02.10.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package graph;

import java.applet.Applet;
import java.util.*;
import java.awt.*;
import java.text.*;

/**
 * @author jfranke
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class Starter extends Applet {
	String[][] values; //Daten und Skalen
	int width; //Breite des Applets
	int height; //Hhe des Applets
	int upper_border; //obere Grenze des Diagrammbereichs
	int left_border; //linke Grenze des Diagrammbereichs
	int right_border; //Rechte Grenze des Diagrammbereichs
	int lower_border; //Untere Grenze des Diagrammbereichs
	Font font; //Standardfont zur Anzeige im Applet
	Font stdbold; //Standardfont bold
	Font stdsmall; //Kleine Beschriftung fr Legende
	Font labelsfont; //Font fr Beschriftungen
	FontMetrics fm; //Font Metriken
	FontMetrics fmsmall; //Font Metriken
	FontMetrics fmlabels; //Font Metriken
	DecimalFormat df;
	Color color_total; //Farbe fr Gesamtbalken
	Color color_branch; //Farbe Branche
	Color color_sanswer; //Farbe der eigenen Antwort
	Graphics g;
	StdGraph myGraph;
	/**
	 * @throws java.awt.HeadlessException
	 */
	public Starter() throws HeadlessException {
		super();

	}

	public void init() {
		System.out.println("***   EFL-Tracker Visualization    ***");
		System.out.println("***Univentures GmbH, J. Franke 2003***");
		System.out.println("***             Ver 1.4            ***");

		g = getGraphics();

		//Parameter einlesen
		//Groesse des Applets ermitteln

		width = getSize().width;
		height = getSize().height;

		upper_border = 35;
		left_border = 60;
		right_border = 130;
		lower_border = 40;

		if (getParameter("type") != null) {
			if (getParameter("type").equals("Bars")) {
				getParametersBars();
				myGraph = new BarGraph(values, this, getGraphics());

			}

			if (getParameter("type").equals("BarsFixed")) {
				getParametersBarsFixed();
				myGraph = new BarFixedGraph(values, this, getGraphics());
			}

		} else {
			Font exceptionFont = new Font("SansSerif", Font.BOLD, 12);
			fm = getFontMetrics(exceptionFont);
			g.setFont(exceptionFont);
			String message =
				new String("Missing parameter: Please specify type of graph.");
			g.drawString(
				message,
				width / 2 - fm.stringWidth(message) / 2,
				height / 2);
		}

	}

	public void paint(Graphics g) {
		if (myGraph != null) {
			myGraph.paintGraph();
		}
		if (getParameter("type") != null) {
			if (!(getParameter("type").equals("Bars")
				|| getParameter("type").equals("BarsFixed"))) {
				g.setColor(new Color(255, 255, 255));
				g.fillRect(0, 0, width, height);
				g.setColor(new Color(0, 0, 0));
				Font exceptionFont = new Font("SansSerif", Font.BOLD, 12);
				fm = getFontMetrics(exceptionFont);
				g.setFont(exceptionFont);
				String message =
					new String("This type of graph is not yet supported.");
				g.drawString(
					message,
					width / 2 - fm.stringWidth(message) / 2,
					height / 2);
				message = "Not supported: " + getParameter("type");
				g.drawString(
					message,
					width / 2 - fm.stringWidth(message) / 2,
					height / 2 + fm.getHeight());
			}
		} else {
			g.setColor(new Color(255, 255, 255));
			g.fillRect(0, 0, width, height);
			g.setColor(new Color(0, 0, 0));
			Font exceptionFont = new Font("SansSerif", Font.BOLD, 12);
			fm = getFontMetrics(exceptionFont);
			g.setFont(exceptionFont);
			String message =
				new String("Missing parameter: Please specify type of graph.");
			g.drawString(
				message,
				width / 2 - fm.stringWidth(message) / 2,
				height / 2);
		}
	}

	public void start() {
		paint(g);
	}

	public void getParametersBars() {
		//	Array contains values (0), scales(1), scale values(2), branch values (3), and scales for mean calculation (4)
		int i = 1;
		//Anzahl der Parameter ermitteln
		while (getParameter("values" + i) != null)
			i++;

		values = new String[i][5];

		for (int j = 0; j < i; j++) {
			values[j][0] = getParameter("values" + j);
			values[j][1] = getParameter("scales" + j);
			values[j][2] = getParameter("vscales" + j);
			values[j][3] = getParameter("values_b" + j);
			values[j][4] = getParameter("mscales" + j);
		}

	}

	public void getParametersBarsFixed() {
		//	Array contains values (0), scales(1), scale values(2), branch values (3), and scales for mean calculation (4)
		int i = 1;
		//Anzahl der Parameter ermitteln
		while (getParameter("values" + i) != null)
			i++;

		values = new String[i][6];

		for (int j = 0; j < i; j++) {
			values[j][0] = getParameter("values" + j);
			values[j][1] = getParameter("scales" + j);
			values[j][2] = getParameter("single_value" + j);
			values[j][3] = getParameter("values_b" + j);
			values[j][4] = getParameter("number" + j);
			values[j][5] = getParameter("number_b" + j);

		}

		for (int j = 0; j < values.length; j++) {
			for (int k = 0; k < 6; k++) {
				if(!(values[j][k]==null)){
				
				if (values[j][k].length() == 0 )
					values[j][k] = "n.a.";
				}else{
					values[j][k] = "n.a.";
				}
			}

		}
		/*
		for (int j = 0; j < values.length; j++) {
				for(int k=0;k<6;k++){
					if(values[j][k].equals("")) values[j][k]="n.a.";
					System.out.println("[" + j + "]["+ k + "] =>" + values[j][k]);
				}
				
			}
		*/
	}

}
