/*
 * Created on 27.09.2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package graph;

import java.applet.Applet;
import java.util.*;
import java.awt.*;
import java.text.*;

/**
 * @author jfranke
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class stdgraph_backup extends Applet {
	String[][] values; //Daten und Skalen
	int width; //Breite des Applets
	int height; //Hhe des Applets
	int upper_border; //obere Grenze des Diagrammbereichs
	int left_border; //linke Grenze des Diagrammbereichs
	int right_border; //Rechte Grenze des Diagrammbereichs
	int lower_border; //Untere Grenze des Diagrammbereichs
	Font font; //Standardfont zur Anzeige im Applet
	Font stdbold; //Standardfont bold
	Font stdsmall; //Kleine Beschriftung fr Legende
	Font labelsfont; //Font fr Beschriftungen
	FontMetrics fm; //Font Metriken
	FontMetrics fmsmall; //Font Metriken
	FontMetrics fmlabels; //Font Metriken
	DecimalFormat df;
	Color color_total; //Farbe fr Gesamtbalken
	Color color_branch; //Farbe Branche
	Color color_sanswer; //Farbe der eigenen Antwort

	boolean calc_mean;
	//Mittelwerte fuer diese Darstellung errechnen oder nicht?

	int max_scale; //Maximaler Skalenpunkt

	/**
	 * @throws java.awt.HeadlessException
	 */
	public stdgraph_backup() throws HeadlessException {
		super();

	}

	public void init() {

		System.out.println("*** EFL Tracker Visualization  ***");
		System.out.println("***E-Finance Lab, J. Franke 2003***");
		System.out.println("***          Ver 1.0e           ***");
		//Parameter einlesen
		//Groesse des Applets ermitteln

		width = getSize().width;
		height = getSize().height;

		upper_border = 35;
		left_border = 60;
		right_border = 130;
		lower_border = 40;

		font = new Font("SansSerif", Font.PLAIN, 12);
		stdbold = new Font("SansSerif", Font.BOLD, 12);
		stdsmall = new Font("SansSerif", Font.BOLD, 10);
		labelsfont = new Font("SansSerif", Font.BOLD, 11);
		fm = getFontMetrics(font);
		fmsmall = getFontMetrics(stdsmall);
		fmlabels = getFontMetrics(labelsfont);

		df = new DecimalFormat("#0.0");

		int i = 1;
		//Anzahl der Parameter ermitteln
		while (getParameter("values" + i) != null)
			i++;

		//Array contains values (0), scales(1), scale values(2), branch values (3), and scales for mean calculation (4)
		values = new String[i][5];

		for (int j = 0; j < i; j++) {
			values[j][0] = getParameter("values" + j);
			values[j][1] = getParameter("scales" + j);
			values[j][2] = getParameter("vscales" + j);
			values[j][3] = getParameter("values_b" + j);
			values[j][4] = getParameter("mscales" + j);
		}

		//Farben definieren
		color_total = new Color(255, 153, 0);
		color_branch = new Color(128, 0, 0);
		color_sanswer = new Color(235, 235, 235);

		if (getParameter("mean").equals("true")) {
			calc_mean = true;
		} else {
			calc_mean = false;
		}

	}

	public void start() {
		repaint();
	}

	public void drawSingleValue(Graphics g) {
		//Funktion, um die Einzelantwort auszugeben
		if (!getParameter("single_value").equals("")) {

			int single = Integer.parseInt(getParameter("single_value"));
			int idx = 9999;
			for (int i = 0; i < values.length; i++) {
				if (Integer.parseInt(values[i][2]) == single) {
					idx = i;
				}
			}

			if (idx != 9999) {

				int space_x =
					(int) ((width - left_border - right_border)
						/ values.length);
				g.setColor(color_sanswer);
				g.fillRect(
					left_border + idx * space_x,
					upper_border,
					space_x,
					height - upper_border);
				g.setColor(Color.BLACK);
			}
		}
	}
	public void drawMean(Graphics g, String type) {
		int t = 0; //defaults total
		Color myColor = color_total;
		if (type.equals("total")) {
			t = 0;
			myColor = color_total;
		}
		if (type.equals("branch")) {
			t = 3;
			myColor = color_branch;
		}

		double sum = 0;
		double meansum = 0;
		double mean = 0;
		for (int i = 0; i < values.length; i++) {
			if (!values[i][4].equals("0")) {
				sum += Double.parseDouble(values[i][t]);
			}
		}
		for (int i = 0; i < values.length; i++) {
			meansum += Double.parseDouble(values[i][4])
				* (Double.parseDouble(values[i][t]));
		}
		mean = meansum / sum;
		int k = 0;
		//Anzahl der nicht mitgezaehlten Skalen ermitteln
		for (int i = 0; i < values.length; i++) {
			if (Integer.parseInt(values[i][4]) == 0)
				k++;
		}
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);
		int disp_width = width - left_border - right_border - k * space_x;

		//Ersten Wert als Referenzpunkt festlegen
		double calc = (double) (space_x) / 2 / Integer.parseInt(values[0][4]);

		g.setColor(myColor);
		drawVrtDotLine(
			upper_border,
			height - lower_border,
			(int) (left_border + space_x * mean - calc),
			g);

		g.setColor(Color.BLACK);
	}

	public void drawLegend(Graphics g) {
		g.setFont(stdsmall);
		g.setColor(color_total);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7,
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		g.setColor(color_branch);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7 + fmsmall.getHeight() + 5,
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		if(!getParameter("single_value").equals("")){
		g.setColor(color_sanswer);
		g.fillRect(
			width - right_border + 7,
			upper_border + 7 + 2 * (fmsmall.getHeight() + 5),
			fmsmall.getHeight() - 2,
			fmsmall.getHeight() - 2);
		g.setColor(color_total);
		}
		if (calc_mean) {
			drawVrtDotLine(
				upper_border + 7 + 3 * (fmsmall.getHeight() + 5),
				upper_border
					+ 7
					+ 3 * (fmsmall.getHeight() + 5)
					+ fmsmall.getHeight(),
				width - right_border + 7 + fmsmall.getHeight() / 2,
				g);

			g.setColor(color_branch);
			drawVrtDotLine(
				upper_border + 7 + 4 * (fmsmall.getHeight() + 5),
				upper_border
					+ 7
					+ 4 * (fmsmall.getHeight() + 5)
					+ fmsmall.getHeight(),
				width - right_border + 7 + fmsmall.getHeight() / 2,
				g);
		}
		g.setColor(Color.BLACK);
		g.drawString(
			"Total",
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border + 7 + fmsmall.getAscent()));
		g.drawString(
			"Branch",
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border
				+ 7
				+ fmsmall.getHeight()
				+ 5
				+ fmsmall.getAscent()));
		if(!getParameter("single_value").equals("")){		
		g.drawString(
			"Your answer",
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (upper_border
				+ 7
				+ 2 * (fmsmall.getHeight() + 5)
				+ fmsmall.getAscent()));
		}
		if (calc_mean) {
			g.drawString(
				"Total average",
				(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
				(int) (upper_border
					+ 7
					+ 3 * (fmsmall.getHeight() + 5)
					+ fmsmall.getAscent()));
			g.drawString(
				"Branch average",
				(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
				(int) (upper_border
					+ 7
					+ 4 * (fmsmall.getHeight() + 5)
					+ fmsmall.getAscent()));
			int h = 0;
			for (int i = 0; i < values.length; i++) {
				if (values[i][4].equals("0"))
					h++;
			}
			if (h > 0) {

				g.drawString(
					"Scales not con-",
					(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
					(int) (upper_border
						+ 7
						+ 6 * (fmsmall.getHeight() + 5)
						+ fmsmall.getAscent()));
				g.drawString(
					"tained in average:",
					(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
					(int) (upper_border
						+ 7 * (fmsmall.getHeight() + 5)
						+ fmsmall.getAscent()));
				int p = 0;
				for (int i = 0; i < values.length; i++) {

					if (values[i][4].equals("0")) {
						p++;
						g.drawString(
							"\"" + values[i][1] + "\"",
							(int) (width
								- right_border
								+ 7
								+ fmsmall.getHeight()
								+ 2),
							(int) (upper_border
								+ (7 + p) * (fmsmall.getHeight() + 5)
								- 4
								+ fmsmall.getAscent()));
					}
				}
			}

		}

		int sum = 0;
		int sum_b = 0;
		for (int i = 0; i < values.length; i++) {
			sum += Integer.parseInt(values[i][0]);

		}
		for (int i = 0; i < values.length; i++) {
			sum_b += Integer.parseInt(values[i][3]);
		}
		String star1 = new String();
		String star2 = new String();
		if (sum < 10)
			star1 = "*";
		if (sum_b < 10)
			star2 = "*";

		g.drawString(
			"N(Gesamt)=" + sum + star1,
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (height
				- lower_border
				- 2 * fmsmall.getHeight()
				+ fmsmall.getAscent()));
		g.drawString(
			"N(Branche)=" + sum_b + star2,
			(int) (width - right_border + 7 + fmsmall.getHeight() + 2),
			(int) (height
				- lower_border
				- 1 * fmsmall.getHeight()
				+ fmsmall.getAscent()));

		g.setFont(font);
	}

	public void drawCoords(Graphics g) {

		//Achsen y1,y2,x
		g.drawLine(
			left_border,
			upper_border,
			left_border,
			height - lower_border);
		g.drawLine(
			width - right_border,
			upper_border,
			width - right_border,
			height - lower_border);
		g.drawLine(
			left_border,
			height - lower_border,
			width - right_border,
			height - lower_border);

		//Errechne y-Achse

		//Maximal darzustellenden Wert ermitteln
		double sum = 0;
		double sum_b = 0;
		for (int i = 0; i < values.length; i++) {
			sum += Double.parseDouble(values[i][0]);
			sum_b += Double.parseDouble(values[i][3]);
		}

		double max_value = 0;
		for (int i = 0; i < values.length; i++) {
			double value = Double.parseDouble(values[i][0]) / sum;
			if (value > max_value)
				max_value = value;
			double value2 = Double.parseDouble(values[i][3]) / sum_b;
			if (value2 > max_value)
				max_value = value2;
		}

		//Maximalen Skalenpunkt ermitteln
		max_scale = (int) Math.floor(max_value * 100);

		if (max_scale % 10 >= 4 && max_scale % 10 != 0) {
			max_scale += Math.abs((max_scale % 10) - 10) + 10;
		} else {
			max_scale += Math.abs((max_scale % 10) - 10);
		}
		if (max_scale >= 96)
			max_scale = 100;

		//Optimale Lnge der Anzeige als genaues Vielfaches des max. Skalenpunktes ermitteln
		int max_disp = height - upper_border - lower_border;

		//System.out.println("maxDisp: " + max_disp);

		int scale = (int) Math.floor(max_disp / (max_scale));
		upper_border += height
			- upper_border
			- lower_border
			- scale * max_scale;
		/*
		System.out.println("Scale: " + scale);
		System.out.println(" Values height=" + height + "uB:"+upper_border+"lB:"+lower_border+"sc:"+scale*max_scale);
		
		System.out.println("New Disp:" + (height-upper_border-lower_border+fm.getHeight()/2));
		*/
		//Abstand errechnen
		double space_y =
			(height - upper_border - lower_border) / (max_scale / 10);

		//System.out.println("Dist y: "+ space_y);

		int bottom = height - lower_border;

		//Prozentbeschriftung einfgen
		for (int i = 0; i <= max_scale / 10; i++) {
			String label = i * 10 + ".0%";
			g.drawString(
				label,
				left_border - 55,
				bottom - (int) (i * space_y) + fm.getAscent() / 2);
			if (i > 0) {
				g.setColor(new Color(200, 200, 200));
				drawHrzDotLine(
					left_border + 1,
					width - (right_border + 1),
					bottom - (int) (i * space_y),
					g);
			}
			g.setColor(new Color(0, 0, 0));

		}

		//Skala zeichnen
		drawScale(g);

	}

	public void drawHrzDotLine(int x1, int x2, int y, Graphics g) {
		boolean flag = true;
		int k = 0;
		int l = 3;
		for (int i = 0; i < x2 - x1; i++) {

			if (k > 0) {
				k--;
				flag = false;
			}
			if (l > 0) {
				flag = true;
				l--;
			}
			if (k == 1)
				l = 5;
			if (l == 1)
				k = 5;

			if (flag) {
				//Nur einen Punkt zeichnen
				g.drawLine(x1 + i, y, x1 + i, y);
			}

		}

	}
	public void drawVrtDotLine(int y1, int y2, int x, Graphics g) {
		boolean flag = true;
		int k = 0;
		int l = 3;
		for (int i = 0; i < y2 - y1; i++) {

			if (k > 0) {
				k--;
				flag = false;
			}
			if (l > 0) {
				flag = true;
				l--;
			}
			if (k == 1)
				l = 5;
			if (l == 1)
				k = 5;

			if (flag) {
				//Nur einen Punkt zeichnen
				g.drawLine(x, y1 + i, x, y1 + i);
			}

		}

	}

	public void drawBars(Graphics g, int order, int no_total, String type) {
		double sum = 0;
		int bar_width = 15;
		int t = 0; //defaults to total
		Color myColor = color_total;
		g.setFont(labelsfont);
		if (type.equals("total")) {
			t = 0;
			myColor = color_total;
		}
		if (type.equals("branch")) {
			t = 3;
			myColor = color_branch;
		}
		//Summe errechnen
		for (int i = 0; i < values.length; i++) {
			sum += Double.parseDouble(values[i][t]);
		}

		int disp_height = height - lower_border - upper_border;
		int bottom = height - lower_border;

		for (int j = 0; j < values.length; j++) {
			//Rechtecke fuer jede Angabe zeichnen
			double bar_height = Double.parseDouble(values[j][t]) / sum;
			int space_x =
				(int) ((width - left_border - right_border) / values.length);

			int subspace_x = space_x / (no_total + 1);

			g.setColor(myColor);
			g.fillRect(
				left_border
					+ j * space_x
					+ (order + 1) * subspace_x
					- bar_width / 2,
				bottom - (int) ((bar_height * disp_height) * 100 / max_scale),
				bar_width,
				(int) ((bar_height * disp_height) * 100 / max_scale));

			String datalabel = df.format(bar_height * 100);
			//datalabel += "%";
			/*
			System.out.println("Data: " + datalabel);
			System.out.println("Disp: " + disp_height);
			System.out.println("Bar: " + bar_height);
			System.out.println("height " + ((bar_height * disp_height) * 100 / max_scale));
			System.out.println("MaxScale: " + max_scale);
			*/
			g.setColor(new Color(0, 0, 0));
			g.drawString(
				datalabel,
				(order + 1) * subspace_x
					+ left_border
					+ j * space_x
					- fmlabels.stringWidth(datalabel) / 2,
				(int) (bottom
					- bar_height * disp_height * 100 / max_scale
					- 2));

		}

	}

	public void drawScale(Graphics g) {

		g.setFont(font);
		//Abstand kalkulieren
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);

		for (int i = 0; i < values.length; i++) {

			boolean out_complete = false;

			String output = values[i][1];
			String rest = values[i][1];
			int row = 0;

			while (!out_complete) {

				//Lnge des Strings ermitteln

				int s = fm.stringWidth(rest);

				if (s > space_x - 6) {

					int slen = 0;
					int idx = 0;
					while (slen < space_x - 6 && idx < rest.length()) {
						slen = slen + fm.charWidth(rest.charAt(idx));
						idx++;
					}
					idx--;
					//Vorgelagertes Leerzeichen ermitteln
					while (idx >= 0
						&& rest.charAt(idx) != new String(" ").charAt(0)) {
						idx--;
					}
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);

				} else {
					output = rest;
					out_complete = true;
				}
				s = fm.stringWidth(output);
				g.drawString(
					output,
					space_x / 2 + left_border + i * space_x - s / 2,
					height - lower_border + (1 + row) * fm.getHeight());
				row++;
			}
		}

	}

	public int getMaxScaleRow(){
		int rowMax=0;
		//Abstand kalkulieren
		int space_x =
			(int) Math.floor(
				(width - left_border - right_border) / values.length);

		for (int i = 0; i < values.length; i++) {

			boolean out_complete = false;

			String output = values[i][1];
			String rest = values[i][1];
			int row = 0;

			while (!out_complete) {

				//Lnge des Strings ermitteln

				int s = fm.stringWidth(rest);

				if (s > space_x - 6) {

					int slen = 0;
					int idx = 0;
					while (slen < space_x - 6 && idx < rest.length()) {
						slen = slen + fm.charWidth(rest.charAt(idx));
						idx++;
					}
					idx--;
					//Vorgelagertes Leerzeichen ermitteln
					while (idx >= 0
						&& rest.charAt(idx) != new String(" ").charAt(0)) {
						idx--;
					}
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);

				} else {
					output = rest;
					out_complete = true;
				}

				row++;
			}
			if(row>rowMax) rowMax=row;
		}
		
		return rowMax;
	}

	public void paint(Graphics g) {
		g.setColor(new Color(255, 255, 255));
		g.fillRect(0, 0, width, height);
		g.setColor(new Color(0, 0, 0));

		if (getParameter("type") != null) {
			if (getParameter("type").equals("Bars")) {
				int rows = 0;
				rows = drawAnswer(g);
				upper_border = rows * fm.getHeight() + 5;
				lower_border=getMaxScaleRow()*fm.getHeight()+2;
				drawSingleValue(g);
				drawCoords(g);
				drawLegend(g);
				if (calc_mean) {
					drawMean(g, "total");
					drawMean(g, "branch");
				}
				drawBars(g, 0, 2, "total");
				drawBars(g, 1, 2, "branch");

			} else {
				String message =
					new String("This type of graph is not yet supported.");
				g.drawString(
					message,
					width / 2 - fm.stringWidth(message) / 2,
					height / 2);
				message = "Not supported: " + getParameter("type");
				g.drawString(
					message,
					width / 2 - fm.stringWidth(message) / 2,
					height / 2 + fm.getHeight());

			}
		} else {
			Font exceptionFont = new Font("SansSerif", Font.BOLD, 12);
			fm = getFontMetrics(exceptionFont);
			g.setFont(exceptionFont);
			String message =
				new String("Wrong parameter count. Please specify type of graph.");
			g.drawString(
				message,
				width / 2 - fm.stringWidth(message) / 2,
				height / 2);
		}
	}

	public int drawAnswer(Graphics g) {
		String answer = new String(getParameter("antwort"));
		g.setFont(stdbold);

		boolean out_complete = false;

		String output = answer;
		String rest = answer;
		int row = 0;

		while (!out_complete) {

			//Lnge des Strings ermitteln

			int s = fm.stringWidth(rest);

			if (s > width - 10) {

				int slen = 0;
				int idx = 0;
				while (slen < width - 10 && idx < rest.length()) {
					slen = slen + fm.charWidth(rest.charAt(idx));
					idx++;
				}
				idx--;
				//Vorgelagertes Leerzeichen ermitteln
				while (idx >= 0
					&& rest.charAt(idx) != new String(" ").charAt(0)) {
					idx--;
				}
				if (idx <= 0) {
					out_complete = true;
					output = rest;
				} else {
					output = rest.substring(0, idx);
					rest = rest.substring(idx + 1);
				}
			} else {
				output = rest;
				out_complete = true;
			}
			s = fm.stringWidth(output);
			g.drawString(output, 5, (1 + row) * fm.getHeight());
			row++;
		}

		g.setFont(font);
		return row;
	}

}
