<?php
//Functions for Graph-Generation

function drawHrzDotLine($bild, $x1, $x2, $y, $linecolor){
	$flag=false;
	$k=0;
	$l=3;
		
	for ($i = 0; $i < $x2 - $x1; $i++) {

		if ($k > 0) {
			$k--;
			$flag = false;
		}
		if ($l > 0) {
			$flag = true;
			$l--;
		}
		if ($k == 1)
			$l = 5;
		if ($l == 1)
			$k = 5;
		if ($flag) {
			//Nur einen Punkt zeichnen
			imageline($bild,$x1+$i,$y,$x1+$i,$y,$linecolor);
		}
	}
}

function drawVrtDotLine($bild, $x, $y1, $y2, $linecolor){
	$flag=false;
	$k=0;
	$l=3;
		
	for ($i = 0; $i < $y2 - $y1; $i++) {

		if ($k > 0) {
			$k--;
			$flag = false;
		}
		if ($l > 0) {
			$flag = true;
			$l--;
		}
		if ($k == 1)
			$l = 5;
		if ($l == 1)
			$k = 5;
		if ($flag) {
			//Nur einen Punkt zeichnen
			imageline($bild,$x,$y1+$i,$x,$y1+$i,$linecolor);
		}
	}
}

function drawGraphArea($bild,$mycolor){

global $LEFT_BORDER;
global $RIGHT_BORDER;
global $UPPER_BORDER;
global $LOWER_BORDER;
global $BAR_WIDTH;
global $SIZE_X;
global $SIZE_Y;
	
   //Zeichenflche vorbereiten / Randlinien zeichnen
  imageline($bild,$LEFT_BORDER,$UPPER_BORDER,$LEFT_BORDER,$SIZE_Y-$LOWER_BORDER,$mycolor);
  imageline($bild,$LEFT_BORDER,$SIZE_Y-$LOWER_BORDER,$SIZE_X-$RIGHT_BORDER,$SIZE_Y-$LOWER_BORDER,$mycolor);
  imageline($bild,$SIZE_X-$RIGHT_BORDER,$UPPER_BORDER,$SIZE_X-$RIGHT_BORDER,$SIZE_Y-$LOWER_BORDER,$mycolor);

}

function drawAnswerText($bild,$txt,$answer){
  global $SIZE_X;
  global $RIGHT_BORDER;
  global $LEFT_BORDER;
	
  $font_metrics=imagettfbbox($answer['size'],0,$answer['font'],$txt);
  $font_height=abs($font_metrics[7]);
  $font_width=abs($font_metrics[2]);
  
  if($font_width>$SIZE_X-$RIGHT_BORDER){
  	
  $char_width=imagettfbbox($answer['size'],0,$answer['font'],"n");
  $max_chars=floor(($SIZE_X-$RIGHT_BORDER)/abs($char_width[2]));
  $text=wordwrap($txt,$max_chars);
  
  $text_arr=split("\n",$text);
  $p=0;
   foreach($text_arr as $tkey => $tvalue){
   	
   $font_metrics=imagettfbbox($answer['size'],0,$answer['font'],$tvalue);
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);
   
   	  
   $pos_x=0;
   $pos_y=($p+1)*$font_height*1.5;
   
   imagettftext($bild,$answer['size'],0,$pos_x,$pos_y,$answer['color'],$answer['font'],$tvalue);

   $p++;	
   }	
  	
  }else{	
  
 imagettftext($bild,$answer['size'],0,0,$font_height,$answer['color'],$answer['font'],$txt);
 
 }
	}

function drawBars($bild,$data,$scale,$bar_color,$order,$number,$bar_text){

global $LEFT_BORDER;
global $RIGHT_BORDER;
global $UPPER_BORDER;
global $LOWER_BORDER;
global $BAR_WIDTH;
global $SIZE_X;
global $SIZE_Y;
global $spacing;
global $max_value;
global $scale_height;
global $scale_sign;
global $scale_max;
global $subst_scale;

$subspace=$spacing/($number+1);

//Draw Bars
foreach($data as $key => $value){
  $i++;
  
  $height=$value/$scale_max*$scale_height;
  $label=number_format($value,1) . $scale_sign;
  
  imagefilledrectangle ($bild, $LEFT_BORDER+($i-1)*$spacing+($order+1)*$subspace-$BAR_WIDTH/2, $SIZE_Y-$LOWER_BORDER-$height, $LEFT_BORDER+($i-1)*$spacing+($order+1)*$subspace+$BAR_WIDTH/2, $SIZE_Y-$LOWER_BORDER, $bar_color);
  
  $font_metrics=imagettfbbox($bar_text['size'],0,$bar_text['font'],$label);
  $font_height=abs($font_metrics[7]);
  $font_width=abs($font_metrics[2]);
  
  $pos_x=$LEFT_BORDER+($i-1)*$spacing+($order+1)*$subspace-$font_width/2;
  $pos_y=$SIZE_Y-$LOWER_BORDER-$height-2;

  imagettftext($bild,$bar_text['size'],0,$pos_x,$pos_y,$bar_text['color'],$bar_text['font'],$label);
  
 //Skala nur im ersten Durchgang beschriften
 if($order==0){ 
 
 if($subst_scale){
   $font_metrics=imagettfbbox($bar_text['size'],0,$bar_text['font'],"(" . ($i) . ")");
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);
  
   $pos_x=$LEFT_BORDER+($i-0.5)*$spacing-$font_width/2;
   $pos_y=$SIZE_Y-$LOWER_BORDER+5+($p+1)*$font_height;
   
   imagettftext($bild,$bar_text['size'],0,$pos_x,$pos_y,$bar_text['color'],$bar_text['font'],"(" . ($i) . ")");
  
 	
 }else{	 
 //Breite des Strings ermitteln
   $font_metrics=imagettfbbox($bar_text['size'],0,$bar_text['font'],$scale[$i-1]);
   $scale_font_height=abs($font_metrics[7]);
   $scale_font_width=abs($font_metrics[2]);
   //echo $scale_font_width . "<br>";

 if($scale_font_width>$spacing){
 
 	
  //Skalenbeschriftung umbrechen
  $char_width=imagettfbbox($bar_text['size'],0,$bar_text['font'],"m");
  $max_chars=floor($spacing/abs($char_width[2]));
  $text=wordwrap($scale[$i-1],$max_chars,"\n",1);
  
  $text_arr=split("\n",$text);
  
   foreach($text_arr as $tkey => $tvalue){
   	
   $font_metrics=imagettfbbox($bar_text['size'],0,$bar_text['font'],$tvalue);
   $font_width=abs($font_metrics[2]);
   
   	  
   $pos_x=$LEFT_BORDER+($i-0.5)*$spacing-$font_width/2;
   $pos_y=$SIZE_Y-$LOWER_BORDER+5+($p+1)*$scale_font_height;
   
   imagettftext($bild,$bar_text['size'],0,$pos_x,$pos_y,$bar_text['color'],$bar_text['font'],$tvalue);

   $p++;	
   }	
   

  }else{	

   $font_metrics=imagettfbbox($bar_text['size'],0,$bar_text['font'],$scale[$i-1]);
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);
  
   $pos_x=$LEFT_BORDER+($i-0.5)*$spacing-$font_width/2;
   $pos_y=$SIZE_Y-$LOWER_BORDER+5+($p+1)*$font_height;
   
   imagettftext($bild,$bar_text['size'],0,$pos_x,$pos_y,$bar_text['color'],$bar_text['font'],$scale[$i-1]);
  }
  $p=0;
}
}
}
	
}

function drawAnswer($bild,$idx,$answ_color,$nokey){
	
$idx--;	

global $LEFT_BORDER;
global $RIGHT_BORDER;
global $UPPER_BORDER;
global $LOWER_BORDER;
global $BAR_WIDTH;
global $SIZE_X;
global $SIZE_Y;
global $spacing;
global $max_value;
global $scale_height;
global $scale_sign;
global $scale_max;
global $meanscale;
$corr=0;

//Check, ob eine reverse-Zuordnung der Skalenwerte vorliegt!
if(count($meanscale)>1){
$reverse=0;	
if($meanscale[0]>$meanscale[1]) $reverse=1;	
}

//Check, ob 5er oder 7er Likert-Skala
if(count($meanscale)==7) $corr=4;
if(count($meanscale)==6) $corr=3;
if(count($meanscale)==5) $corr=3;
if(count($meanscale)==4) $corr=1;
if(count($meanscale)==3) $corr=10;


$disp_height=$SIZE_Y-$UPPER_BORDER-$LOWER_BORDER;

//Draw Answer
if($reverse==0){
  imagefilledrectangle ( $bild, $LEFT_BORDER+($idx+$corr)*$spacing, $SIZE_Y-$LOWER_BORDER-$disp_height, $LEFT_BORDER+($idx+$corr+1)*$spacing, $SIZE_Y-$LOWER_BORDER, $answ_color);
}else{
//Calculate number of scales not included in mean and adjust spacing accordingly
// $nokey supplies this value

  imagefilledrectangle ( $bild, $SIZE_X-$RIGHT_BORDER-($idx+$corr+1+$nokey)*$spacing, $SIZE_Y-$LOWER_BORDER-$disp_height, $SIZE_X-$RIGHT_BORDER-($idx+$corr+$nokey)*$spacing, $SIZE_Y-$LOWER_BORDER, $answ_color);
}
}

function drawLegend($bild,$text_color,$total_color,$branche_color,$answ_color,$font){
	
global $LEFT_BORDER;
global $RIGHT_BORDER;
global $UPPER_BORDER;
global $LOWER_BORDER;
global $SIZE_X;
global $SIZE_Y;
global $ENABLE_BRANCH;
global $ENABLE_GLOBAL;


//Weiter von oberem Rand absetzen
$upper_offset=$UPPER_BORDER+35;
	
  //Texthhe ermitteln
   $font_metrics=imagettfbbox($font['size'],0,$font['font'],"A");
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);
  
   $pos_x=$SIZE_X-$RIGHT_BORDER+5;
   $pos_y=$upper_offset+0*$font_height;
   
   imagettftext($bild,$font['size'],0,$pos_x,$pos_y,$font['color'],$font['font'],"Legende");

if($ENABLE_GLOBAL) $legend[0]="Gesamt";
if($ENABLE_BRANCH) $legend[1]="Ihre Branche";


global $lbl_t;
global $lbl_b;
global $multi_answer;
if(isset($lbl_t) && $ENABLE_GLOBAL) $legend[0]=$lbl_t;
if(isset($lbl_b) && $ENABLE_BRANCH) $legend[1]=$lbl_b;

if(!isset($lbl_t) || is_array($multi_answer)) $legend[2]="Ihre Antwort";

global $disp_mean;
if($disp_mean && !isset($lbl_t)){
if($ENABLE_GLOBAL) $legend[3]="Mittelwert Gesamt";
if($ENABLE_BRANCH) $legend[4]="Mittelwert Branche";
}


$i=1.7;
foreach($legend as $key => $value){

$pos_x=$SIZE_X-$RIGHT_BORDER+15;
$pos_y=$upper_offset+4+$i*($font_height+2);
imagettftext($bild,$font['size'],0,$pos_x,$pos_y,$font['color'],$font['font'],$value);
$i++;	

}
$p=1;
if($ENABLE_GLOBAL){
 imagefilledrectangle ( $bild, $SIZE_X-$RIGHT_BORDER+5,$upper_offset+4+$p*$font_height+2,$SIZE_X-$RIGHT_BORDER+10,$upper_offset+9+$p*$font_height+2, $total_color);	
 $p++;
 }
 if($ENABLE_BRANCH){
  imagefilledrectangle ( $bild, $SIZE_X-$RIGHT_BORDER+5,$upper_offset+4+$p*$font_height+4,$SIZE_X-$RIGHT_BORDER+10,$upper_offset+9+$p*$font_height+4, $branche_color);	
  $p++;
 } 
 if(!isset($lbl_t) || is_array($multi_answer)){
  imagefilledrectangle ( $bild, $SIZE_X-$RIGHT_BORDER+5,$upper_offset+4+$p*$font_height+6,$SIZE_X-$RIGHT_BORDER+10,$upper_offset+9+$p*$font_height+6, $answ_color);	
  $p++;
 } 

 if($disp_mean){
 //MW Infos zeichnen
 if($ENABLE_GLOBAL){
 	 drawVrtDotLine($bild,$SIZE_X-$RIGHT_BORDER+7,$upper_offset+4+$p*$font_height+8,$upper_offset+12+$p*$font_height+8,$total_color);
 $p++;
}
 if($ENABLE_BRANCH) drawVrtDotLine($bild,$SIZE_X-$RIGHT_BORDER+7,$upper_offset+4+$p*$font_height+10,$upper_offset+12+$p*$font_height+10,$branche_color);
 }


}

function drawMean($bild,$data,$meanscale,$color,$nokey){
//Funktion zur Zeichnung des Mittelwertes

global $LEFT_BORDER;
global $RIGHT_BORDER;
global $UPPER_BORDER;
global $LOWER_BORDER;
global $spacing;
global $SIZE_Y;
global $SIZE_X;
$corr=0;

//Mittelwert ermitteln
$length=count($data);

//Check, ob eine reverse-Zuordnung der Skalenwerte vorliegt!
if(count($meanscale)>1){
$reverse=0;	
if($meanscale[0]>$meanscale[1]) $reverse=1;	
}	

//Check, ob 5er oder 7er Likert-Skala
if(count($meanscale)==7) $corr=3.5;
if(count($meanscale)==6) $corr=2.5;
if(count($meanscale)==5) $corr=2.5;
if(count($meanscale)==4) $corr=0.5;
if(count($meanscale)==3) $corr=-0.5;

for($i=0;$i<$length;$i++){
$meanzaehler+=$data[$i]*$meanscale[$i];	
if($meanscale[$i]!=100) $meannenner+=$data[$i]; //Nicht im MW aufgenommene Skalen nicht mitzaehlen
}
if($meannenner>0){	
$mean=$meanzaehler/$meannenner;

if($reverse==0){
$pos_x=$LEFT_BORDER+($mean+$corr)*$spacing;
}else{
$pos_x=$SIZE_X-$RIGHT_BORDER-($mean+$corr-($nokey+1))*$spacing;
}

$pos_y1=$UPPER_BORDER;
$pos_y2=$SIZE_Y-$LOWER_BORDER;

  //imageline($bild,$pos_x1,$pos_y1,$pos_x2,$pos_y2,$color);
  
  drawVrtDotLine($bild,$pos_x,$pos_y1,$pos_y2,$color);
}
}

function drawInfo($bild,$data,$scales,$font,$smallfont){
	
global $SIZE_X;
global $SIZE_Y;
global $RIGHT_BORDER;
global $UPPER_BORDER;
global $subst_scale;
global $ENABLE_BRANCH;
global $ENABLE_GLOBAL;

//Weiter von oberem Rand absetzen
$upper_offset=$UPPER_BORDER+35;


if($subst_scale){
//Skalenwerte auslesen und am Rand darstellen
   $font_metrics=imagettfbbox($font['size'],0,$font['font'],"A");
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);
   
   $pos_x=$SIZE_X-$RIGHT_BORDER+5;  
   
global $scale;
for($i=0;$i<count($scale);$i++){
$p++;  
  $pos_y=$upper_offset+(10+$p)*$font_height*1.15;
  imagettftext($bild,$font['size'],0,$pos_x,$pos_y,$font['color'],$font['font'],"(" . ($i+1) . ") " . $scale[$i]);
	
}

	
}else{
global $disp_mean;
if($disp_mean){
//Hier Infos ber nicht aufgenommene Skalenwerte	
$length=count($data);

   $font_metrics=imagettfbbox($font['size'],0,$font['font'],"A");
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);
  
   $pos_x=$SIZE_X-$RIGHT_BORDER+5;   

  for($i=0;$i<$length;$i++){
  
  if($data[$i]==100){
   $pos_y=$upper_offset+(13.5+$p)*$font_height;
   imagettftext($bild,$font['size'],0,$pos_x,$pos_y,$font['color'],$font['font'],"\"" . $scales[$i] . "\"");
   $p++;
  }
	
  }
  if($p>0){
  $pos_y=$upper_offset+(10+$p)*$font_height;
  imagettftext($bild,$font['size'],0,$pos_x,$pos_y,$font['color'],$font['font'],"Scales not inclu-");
  $pos_y=$upper_offset+(11+$p)*$font_height;
  imagettftext($bild,$font['size'],0,$pos_x,$pos_y,$font['color'],$font['font'],"ded in average:");	
  }
}

global $no_numbers;
if(!$no_numbers){

//Anzahl Ns der Stichprobe ausgeben
 $font_metrics=imagettfbbox($font['size'],0,$font['font'],"A");
   $font_height=abs($font_metrics[7]);
   $font_width=abs($font_metrics[2]);

global $n_total;
global $n_branche;
$pos_x=$SIZE_X-$RIGHT_BORDER+5; 

if($n_total<10) $flag="*";
if($n_branche<10) $flag_b="*";
  $pos_y=$upper_offset+(17+$p)*$font_height;
  if($ENABLE_GLOBAL) imagettftext($bild,$font['size'],0,$pos_x,$pos_y,$font['color'],$font['font'],"N(Gesamt)=" . $n_total . $flag);
  $pos_y=$upper_offset+5+(18+$p)*$font_height;
  if($ENABLE_BRANCH) imagettftext($bild,$font['size'],0,$pos_x,$pos_y,$font['color'],$font['font'],"N(Branche)=" . $n_branche . $flag_b);

}
}
//Erstellungdatum einfgen
$pos_x=$SIZE_X-$RIGHT_BORDER+5; 
$pos_y=$SIZE_Y-$font_height;
  imagettftext($bild,$smallfont['size'],0,$pos_x,$pos_y,$smallfont['color'],$smallfont['font'],"Erstellt: " . date("d.m.Y"));



}

function drawBGImage($orig,$bg){
$bg = @imagecreatefrompng ($bg) or die ("Cannot Initialize new GD image stream");
$new_img=imagecopymerge($orig,$bg,0,0,0,0,600,320,15);
return $new_img;
}



?>
